import mysql.connector
from mysql.connector import Error


class DatabaseUploader:
    def __init__(self, config):
        self.config = config
        self.connection = None
        self.connect()

    def connect(self):
        # Establish connection through config file
        try:
            self.connection = mysql.connector.connect(**self.config)
            self.connection.autocommit = True
        except Error as e:
            print(f"Error connecting to MySQL database via config file.: {e}")

    def insert_metadata(self, manufacturer, model, year_start, year_end, image_type, file_path, file_name):
        if self.connection.is_connected():
            cursor = self.connection.cursor()
            # Ignore clause to ignore in case of duplicates, MySQL 5.7.5 and higher
            add_image_query = (
                "INSERT IGNORE INTO images "
                "(manufacturer, model, year_start, year_end, image_type, file_path, file_name) "
                "VALUES (%s, %s, %s, %s, %s, %s, %s)"
            )
            image_data = (manufacturer, model, year_start, year_end, image_type, file_path, file_name)
            cursor.execute(add_image_query, image_data)
            cursor.close()

    def close(self):
        # Close db connection
        if self.connection.is_connected():
            self.connection.close()
