import os
import csv
from datetime import datetime


class LogInvalidUrls:
    def __init__(self, log_directory):
        self.log_directory = log_directory
        if not os.path.exists(self.log_directory):
            os.makedirs(self.log_directory)

    def log(self, invalid_urls):
        log_file = os.path.join(self.log_directory, f"{datetime.now().strftime('%Y%m%d')}_bLinks_logs.csv")
        with open(log_file, 'a', newline='') as file:
            writer = csv.writer(file)
            for url, error in invalid_urls:
                writer.writerow([url, error])
